<script>
  import { createEventDispatcher } from "svelte";
  import { fade, scale } from "svelte/transition";
  export let title;
  export let visible;

  const dispatch = createEventDispatcher();

  function closeModal(event) {
    if (!open) return;
    if (event.type == "keydown" && event.keyCode != 27) return;
    visible = false;
    dispatch("close");
  }

  $: {
    document.documentElement.style.overflow = visible ? "hidden" : "visible";
  }
</script>

<style>
  .modal {
    position: fixed;
    width: 100vw;
    height: 100vh;
    top: 0;
    z-index: 1;
  }

  .overlay {
    width: 100%;
    height: 100%;
    background: #000a;
  }

  .content {
    position: fixed;
    --size: 515px;
    width: 100vw;
    max-width: var(--size);
    min-height: calc(var(--size) * 2 / 3);
    max-height: 100vh;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);

    background: #fefefe;
    border-radius: 3px;
    padding: 20px;

    box-sizing: border-box;
  }

  .close {
    background: transparent;
    border: none;
    padding: 0;
    margin: 0 0 5px 0;
    cursor: pointer;

    font-size: 25px;
    float: right;
  }

  .title {
    font-size: 1.5em;
    margin-bottom: 5px;
    color: #333;
  }

  @media (max-width: 500px) {
    .content {
      height: 100vh;
      overflow: scroll;
      border-radius: 0;
    }
  }
</style>

<svelte:window on:keydown={closeModal} />
{#if visible}
  <div class="modal">
    <div
      class="overlay"
      transition:fade={{ duration: 200 }}
      on:click={closeModal} />
    <div class="content" transition:scale={{ start: 0.95, duration: 300 }}>
      <button class="close" on:click={closeModal}>✖</button>
      <h3 class="title">{title}</h3>
      <slot />

    </div>
  </div>
{/if}
